
import java.io.*;
import java.lang.reflect.*;

class x
{
    public static void main (String argv[])
    {
	try
	{
	  BufferedReader b = new BufferedReader(
	      new InputStreamReader(System.in));

	  Class c = null;

	  while (c == null)
	  {
		System.out.print("Bitte einen Klassennamen eingeben: > ");

	  	try
		{
		   c = Class.forName(b.readLine());
		}
		catch (ClassNotFoundException e)
		{
		   System.out.println("Klasse nicht gefunden.");
		}
	  }

	  System.out.println("\nDie Klasse " + c.getName() + " hat " +
	  	"folgende Methoden:\n");

	  Method m[] = c.getMethods();

	  for (int i=0; i < m.length; i++)
	  {
	     System.out.print( m[i].getReturnType().getName() + " " +
	     		m[i].getName() + "(" );

	     Class parameters[] = m[i].getParameterTypes();

	     for (int j=0; j < parameters.length; j++)
	     {
	     	if (j > 0) System.out.print(", ");
		System.out.print(parameters[j].getName());
	     }

	     System.out.println( ")" );
	  }
	  


	  Object obj = c.newInstance(); // Konstruktor ohne Parameter

	  System.out.print("\nWelche Methode soll (ohne Argumente) aufgerufen werden? > ");

	  Object result = c.getMethod(b.readLine(), null).invoke(obj, null);
	  				// ohne Argumente aufrufen
	  

	  System.out.println("\nRueckgabewert: (" +
	  	result.getClass().getName() + ") " + result + "\n");


	}
	catch (Exception e)
	{
	    e.printStackTrace();
	}
    }
}
